Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
NodeReferenceCount Class Reference

This class specializes ReferenceCount to add an additional counter, called node_ref_count, for the purposes of counting the number of times the object is referenced by a "node", whatever that may mean in context. More...

`#include "nodeReferenceCount.h"`

Inheritance diagram for NodeReferenceCount:

## Public Member Functions
int | get_node_ref_count () const
| Returns the current reference count.
void | node_ref () const
| Explicitly increments the node reference count and the normal reference count simultaneously.
bool | node_unref () const
| Explicitly decrements the node reference count and the normal reference count simultaneously.
void | node_unref_only () const
| Decrements the node reference count without affecting the normal reference count.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

This class specializes ReferenceCount to add an additional counter, called node_ref_count, for the purposes of counting the number of times the object is referenced by a "node", whatever that may mean in context.

The new methods node_ref() and node_unref() automatically increment and decrement the primary reference count as well. There also exists a NodePointerTo<> class to maintain the node_ref counters automatically.

See also CachedTypedWritableReferenceCount, which is similar in principle, as well as NodeCachedReferenceCount, which combines both of these.

Definition at line 33 of file nodeReferenceCount.h.

## Member Function Documentation

## ◆ get_class_type()

static TypeHandle NodeReferenceCount::get_class_type | ( |  | ) |
| inline static

Definition at line 54 of file nodeReferenceCount.h.

## ◆ get_node_ref_count()

int NodeReferenceCount::get_node_ref_count | ( |  | ) | const
| inline

Returns the current reference count.

Definition at line 109 of file nodeReferenceCount.I.

References AtomicAdjustDummyImpl::get(), and test_ref_count_integrity().

## ◆ init_type()

static void NodeReferenceCount::init_type | ( |  | ) |
| inline static

Definition at line 58 of file nodeReferenceCount.h.

## ◆ node_ref()

void NodeReferenceCount::node_ref | ( |  | ) | const
| inline

Explicitly increments the node reference count and the normal reference count simultaneously.

Definition at line 121 of file nodeReferenceCount.I.

References AtomicAdjustDummyImpl::inc(), ReferenceCount::ref(), and test_ref_count_integrity().

## ◆ node_unref()

bool NodeReferenceCount::node_unref | ( |  | ) | const
| inline

Explicitly decrements the node reference count and the normal reference count simultaneously.

The return value is true if the new reference count is nonzero, false if it is zero.

Definition at line 138 of file nodeReferenceCount.I.

References node_unref_only(), and ReferenceCount::unref().

## ◆ node_unref_only()

void NodeReferenceCount::node_unref_only | ( |  | ) | const
| inline

Decrements the node reference count without affecting the normal reference count.

Intended to be called by derived classes only, presumably to reimplement node_unref().

Definition at line 162 of file nodeReferenceCount.I.

References AtomicAdjustDummyImpl::dec(), and test_ref_count_integrity().

Referenced by node_unref().

## ◆ test_ref_count_integrity()

bool NodeReferenceCount::test_ref_count_integrity | ( |  | ) | const
| inline

Does some easy checks to make sure that the reference count isn't completely bogus.

Definition at line 148 of file nodeReferenceCount.I.

Referenced by get_node_ref_count(), node_ref(), and node_unref_only().

The documentation for this class was generated from the following files:

- panda/src/express/nodeReferenceCount.h
- panda/src/express/nodeReferenceCount.cxx
- panda/src/express/nodeReferenceCount.I